class DivISOr
  def self.validate_iso3166(*args)
    ISO3166::Codes.new.validate(*args)
  end

  def self.validate_iso4217(*args)
    ISO4217::Codes.new.validate(*args)
  end

  def self.validate_iso10383(*args)
    ISO10383::Codes.new.validate(*args)
  end

  def self.iso4217(*args)
    self.all(ISO4217, args)
  end

  def self.iso3166(*args)
    self.all(ISO3166, args).first
  end

  def self.iso10383(*args)
    self.all(ISO10383, args).first
  end

  def self.list_iso4217
    self.all(ISO4217)
  end

  def self.list_iso3166
    self.all(ISO3166)
  end

  def self.list_iso10383
    self.all(ISO10383)
  end

  private
  def self.all(object, args=nil)
    object::Codes.new.all(*args) do |record|
      object.new(record)
    end
  end
end
