module ISO
  def initialize
    @iso_records = ISORecords.new self.file_data
  end

  def validate(value, field=:code)
    !value.nil? && values(field).include?(value.to_s.upcase)
  end

  def all(value, field=:code)
    @iso_records.all(value, field).map do |record|
      yield record
    end
  end

  private
  def values(field)
    @iso_records.values_for(field)
  end

  protected
  def file_data
    File.expand_path(File.dirname(__FILE__) + self.class::PATH)
  end
end

